#version 330 core
layout (triangles) in;
layout (triangle_strip, max_vertices=18) out;

uniform mat4 envMatrices[6];

out vec3 FragPos; // FragPos from GS (output per emitvertex)
out vec3 Normal;
out vec2 TexCoords;


in VS_OUT {
	 vec3 Normals;
	 vec3 FragPos;
	 vec2 Texcoords;
} gs_in[];



void main()
{
    for(int face = 0; face < 6; ++face)
    {
        gl_Layer = face; // built-in variable that specifies to which face we render.
        for(int i = 0; i < 3; ++i) // for each triangle's vertices
        {
            FragPos = vec3(gl_in[i].gl_Position);
            gl_Position = envMatrices[face] * gl_in[i].gl_Position;
			TexCoords = gs_in[i].Texcoords;
			Normal = gs_in[i].Normals;
            EmitVertex();
        }    
        EndPrimitive();
    }
}  