#version 330 core
layout (triangles) in;
layout (triangle_strip, max_vertices=18) out;

uniform mat4 envMatrices[6];

out vec3 TexCoords;

in vec3 Texcoords[];


void main()
{
    for(int face = 0; face < 6; ++face)
    {
        gl_Layer = face; // built-in variable that specifies to which face we render.
        for(int i = 0; i < 3; ++i) // for each triangle's vertices
        {
            gl_Position = envMatrices[face] * gl_in[i].gl_Position;
			TexCoords = Texcoords[i];
            EmitVertex();
        }    
        EndPrimitive();
    }
}  